/*
 *  CheckerMaterial.h
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/10/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef CHECKERMATERIAL_H
#define CHECKERMATERIAL_H

#include "Material.h"
#include "Point.h"
#include "Vector.h"
#include "HitRecord.h"

class CheckerMaterial : public Material {
	public:
	CheckerMaterial(const Point &newP1, const Vector &newV1, const Vector &newV2, Material *newMaterial1, Material *newMaterial2);
	CheckerMaterial(const Point &newP1, const Vector &newV1, const Vector &newV2, const Vector &newV3, Material *newMaterial1, Material *newMaterial2);

	virtual ~CheckerMaterial() {}
	
	virtual void shade(Color &result, const RenderContext &context,
			   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;
	
	private:
		Point p1;
		Vector v1;
		Vector v2;
		Vector v3;
		Material *material1;
		Material *material2;
};

#endif