/*
 *  Sampler.h
 *  Assignment8
 *
 *  Created by Zach Gildersleeve on 3/19/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef SAMPLER_H
#define SAMPLER_H

class Sampler
{
	public:
		int numberSamples;
		double inverseSamples;
		double invSamplesMult;
		
		Sampler() {}
		Sampler(int number){number = numberSamples;}
		
		virtual ~Sampler() {}
		
		virtual void getSamples(double x, double y, int support, double *xs, double *ys) {}
};

class UniformSampler : public Sampler
{
	public:
		UniformSampler() {numberSamples = 1;}
		UniformSampler(int number);
		
		virtual void getSamples(double x, double y, int support, double *xs, double *ys);
};

class JitteredSampler : public Sampler
{
	public:
		JitteredSampler() {numberSamples = 1;}
		JitteredSampler(int number);
		
		virtual void getSamples(double x, double y, int support, double *xs, double *ys);
};

#endif SAMPLER_H