#include "Scene.h"
#include "ConstantBackground.h"
#include "Group.h"
#include "LambertMaterial.h"
#include "PointLight.h"
#include "DirectionalLight.h"
#include "PinholeCamera.h"
#include "OrthographicCamera.h"
#include "Plane.h"
#include "Disc.h"
#include "Ring.h"
#include "Triangle.h"
#include "Box.h"
#include "Cylinder.h"
#include "HeightField.h"
#include "Filter.h"
#include "Sampler.h"
#include "MetalMaterial.h"

static int assignment = 4;

//Scene* make_scene()
//{
//	Scene* scene = new Scene();
//	scene->setBackground(new ConstantBackground(Color(.2, .2, .9)));
//	Group* world = new Group();
//	world->addObject(new Disc(new LambertMaterial(Color(1, 1, 0), 1, 1),
//							  Point(10, 20, 2.5), Vector(0, 1, 0), 1.5));
//	world->addObject(new Disc(new LambertMaterial(Color(209.0/255.0, 146.0/255/0, 40.0/255.0), 0.5, 0.5),
//							  Point(10, 30, 2.5), Vector(0, 1, 0), 10));
//	world->addObject(new Disc(new LambertMaterial(Color(80.0/255.0, 40.0/255/0, 209.0/255.0), 1, 1),
//							  Point(10, 40, 2.5), Vector(0, 1, 0), 20));
//							  
////	world->addObject(new Disc(new LambertMaterial(Color(1, 1, 1), 1, 1),
////							  Point(0, 0, 2.5), Vector(0, 1, 0), 0.5));
//	//  Material* Disc2matl = new LambertMaterial(Color(.2, 1, .2), .6, .4);
//	//  world->addObject(new Disc(Disc2matl,
//	//                            Point(2.5, -3.3, 2.5), Vector(-1, -1, 1), .5));
//	//  world->addObject(new Disc(Disc1matl,
//	//                            Point(2., -3.3, 2.5), Vector(-1, -1, 1), .5));
//	//  world->addObject(new Disc(Disc2matl,
//	//                            Point(1.5, -3.3, 2.5), Vector(-1, -1, 1), .5));
//	//  world->addObject(new Disc(Disc1matl,
//	//                            Point(1., -3.3, 2.5), Vector(-1, -1, 1), .5));
//	//  Material* spherematl = new LambertMaterial(Color(1, 0, 0), .6, .4);
//	//  world->addObject(new Sphere(spherematl,
//	//                              Point(-2, 2, 5), .8));
//	//  Material* ringmatl = new LambertMaterial(Color(.25, .25, 1), .6, .4);
//	//  world->addObject(new Ring(ringmatl,
//	//                            Point(-2, 2, 5), Vector(1, -1, 1), 1.2, 1.8));
//	//  world->addObject(new Ring(ringmatl,
//	//                            Point(-2, 2, 5), Vector(1, -1, 1), 2.2, 2.8));
//	Material* trimatl = new LambertMaterial(Color(23.0/255.0, 95.0/255.0,11.0/255.0), .6, .4);
//	for (int i = 0; i < 50; i++)
//	{
//		float z = (rand() % 20);
//		float zScale = z * 0.1;
//		float x = -10 + (rand() % 30);
//		float y = (rand() % 10) * 0.1;
//		world->addObject(new Triangle(trimatl, Point((-.25 + x),z,y), Point((.25 + x),z,y), Point((0 + x), z, (y + 1))));		 
//	}
//	for (int i = 0; i < 100; i++)
//	 {
//		float z = (rand() % 10);
//		float zScale = z * 0.1;
//		float x = -10 + (rand() % 30);
//		float y = (rand() % 10) * 0.1 + .5;
//		 world->addObject(new Triangle(trimatl, Point((-.25 + x),z,y), Point((.25 + x),z,y), Point((0 + x), z, (y + 1))));		 
//	 }
//	for (int i = 0; i < 20; i++)
//	{
//		float z = (rand() % 10) - 10;
//		float zScale = z * 0.1;
//		float x = -20 + (rand() % 30);
//		float y = (rand() % 10) * 0.1 + .5;
//		world->addObject(new Triangle(trimatl, Point((-.5 + x),z,y), Point((.5 + x),z,y), Point((0 + x), z, (y + 2))));		 
//	}
//	for (int i = 0; i < 20; i++)
//	{
//		float z = (rand() % 10) - 20;
//		float zScale = z * 0.1;
//		float x = -20 + (rand() % 30);
//		float y = (rand() % 10) * 0.1 + .5;
//		world->addObject(new Triangle(trimatl, Point((-.5 + x),z,y), Point((.5 + x),z,y), Point((0 + x), z, (y + 2))));		 
//	}
//	
//	Material* hfmatl = new LambertMaterial(Color(.361, .29, .184), .8, .2);
//	world->addObject(new HeightField(hfmatl,
//									 "/Users/zachgildersleeve/Documents/SocS2007/cs6620-RayTracing/Assignment4/test.hf",
//									 
//									 //                                   "/Users/zachgildersleeve/Documents/SocS2007/cs6620-RayTracing/Assignment4/hf1.hf",
//									 Point(-20.5, -20.5, -1), Point(20.5, 20.5, 3)));
//	scene->setObject(world);
//	
//	scene->setAmbient(Color(.4, .4, .4));
//	scene->addLight(new PointLight(Point(-40, -40, 100), Color(.8,.8,.8)));
//	scene->addLight(new PointLight(Point(80, 20, 60), Color(.5,.3,.3)));
//	
//	//scene->setCamera(new PinholeCamera(Point(-2.5, -20, 10),
//	scene->setCamera(new PinholeCamera(Point(3, -28.5, 4),
//									   Point(3.0, 5, 0),
//									   Vector(0, 0, 1),
//									   26));
//	
//	return scene;
//}

Scene* make_scene()
{
  Scene* scene = new Scene();
  scene->setBackground(new ConstantBackground(Color(.3, .6, .5)));
  Group* world = new Group();
  Material* Disc1matl = new LambertMaterial(Color(1, .2, .2), .6, .4);
  world->addObject(new Disc(Disc1matl,
                            Point(3., -3.3, 2.5), Vector(-1, -1, 1), .5));
  Material* Disc2matl = new LambertMaterial(Color(.2, 1, .2), .6, .4);
  world->addObject(new Disc(Disc2matl,
                            Point(2.5, -3.3, 2.5), Vector(-1, -1, 1), .5));
  world->addObject(new Disc(Disc1matl,
                            Point(2., -3.3, 2.5), Vector(-1, -1, 1), .5));
  world->addObject(new Disc(Disc2matl,
                            Point(1.5, -3.3, 2.5), Vector(-1, -1, 1), .5));
  world->addObject(new Disc(Disc1matl,
                            Point(1., -3.3, 2.5), Vector(-1, -1, 1), .5));
  Material* spherematl = new LambertMaterial(Color(1, 0, 0), .6, .4);
  Material* ball_matl = new MetalMaterial(Color(0.96, 0.89, 0.37), 200);

  world->addObject(new Sphere(ball_matl,
                              Point(-2, 2, 5), .8));
  Material* ringmatl = new LambertMaterial(Color(.25, .25, 1), .6, .4);
  world->addObject(new Ring(ringmatl,
                            Point(-2, 2, 5), Vector(1, -1, 1), 1.2, 1.8));
  world->addObject(new Ring(ringmatl,
                            Point(-2, 2, 5), Vector(1, -1, 1), 2.2, 2.8));
  Material* trimatl = new LambertMaterial(Color(1, 1, 0), .6, .4);
  world->addObject(new Triangle(trimatl,
                                Point(1,1,4), Point(3,-.5,2), Point(3, 1.5, 6)));
  Material* hfmatl = new LambertMaterial(Color(.5, 1, 1), .8, .2);
  world->addObject(new HeightField(hfmatl,
                                   "/Users/zachgildersleeve/Documents/SocS2007/cs6620-RayTracing/Assignment4/hf1.hf",
                                   Point(-4.5, -4.5, -1), Point(4.5, 4.5, 3)));
  scene->setObject(world);
  
  int subDivisions = 2;
  int support = 2;
  scene->setSampler(new UniformSampler(subDivisions));
  scene->setFilter(new TriangleFilter(support));

  scene->setAmbient(Color(.4, .4, .4));
  scene->addLight(new PointLight(Point(-40, -40, 100), Color(.8,.8,.8)));
  scene->addLight(new PointLight(Point(80, 20, 60), Color(.5,.3,.3)));

  scene->setCamera(new PinholeCamera(Point(-2.5, -20, 10),
                                     Point(0.5, 0, 4.5),
                                     Vector(0, 0, 1),
                                     26));

  return scene;
}
