/*
 *  Disc.h
 *  Assignment3
 *
 *  Created by Zach Gildersleeve on 2/4/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef DISC_H
#define DISC_H

#include "Primitive.h"
#include "Ray.h"
#include "HitRecord.h"


class Disc : public Primitive {
	public:
		Disc(Material *newMaterial, const Point &newCenter, const Vector &newNormal, double newRadius);
		
	virtual ~Disc() {
		
	}
		virtual void getBounds(BoundingBox& bbox) const;
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;
	
	private:
		Point center;
		double radius;
		double radiusSquared;
		double d;
		Vector normalVector;
	
};

#endif