clear all;
i = double(imread('finalBig1gray.png'));
ft = fftshift(fft2(i));

nSpec = log(abs(ft) + 1);
maxv = max(max(nSpec));
minv = min(min(nSpec));
nSpec = (nSpec - minv) / (maxv - minv);

figure('Position', [0 0 512 512]);axes('position', [0, 0, 1, 1]);image(nSpec); colormap gray; axis([0 512 0 512]); axis off;
