/*
 *  Group.cpp
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/29/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Group.h"
#include <iostream>

Group::Group() {
	listSize = 0;
}

Group::Group(int size) {
	listSize = 0;
	objectList.reserve(size);
}

Group::~Group() {
	
}

void Group::preprocess() {
	listSize = objectList.size();
	
	for (int i = 0; i < listSize; i++)
	{
		objectList[i]->preprocess();
	}
	
}

void Group::addObject(Object *obj) {
	objectList.push_back(obj);
	listSize++;
}

bool Group::intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const {
	bool result = false;
	bool temp = false;
	for (int i = 0; i < listSize; i++)
	{
		temp = objectList[i]->intersect(hit, context, ray);
//		result = result || temp;
	}
	//		result = result || temp;
	return result || temp;
}

void Group::getBounds(BoundingBox& bbox) const {
	for (int i = 0; i < listSize; i++)
	{
		objectList[i]->getBounds(bbox);
	}
}