/*
 *  Object.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/28/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef OBJECT_H
#define OBJECT_H

class HitRecord;
class RenderContext;
class Ray;
#include "BoundingBox.h";

class Object {
	public:
	
		BoundingBox bbox;
		Object();
		virtual ~Object();
		
		virtual void preprocess();
		virtual void getBounds(BoundingBox& bbox) const = 0;
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const = 0;
		
		Object(const Object &o);
		Object &operator=(const Object &o);
};

#endif