/*
 *  TileMaterial.h
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/16/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef TILEMATERIAL_H
#define TILEMATERIAL_H

#include "Material.h"
#include "Point.h"
#include "Vector.h"
#include "HitRecord.h"

class TileMaterial : public Material {
	public:
		TileMaterial(const Point &newP1, const Vector &newV1, const Vector &newV2,
					 Material *newMaterial1, Material *newMaterial2, double newGrout);

		virtual ~TileMaterial() {}

		virtual void shade(Color &result, const RenderContext &context,
						   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;

	private:
		Point p1;
		Vector v1;
		Vector v2;
		Vector v3;
		Material *material1;
		Material *material2;
		double grout;
	
	
};


#endif